VERSION 5.00
Begin VB.Form frmSender 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Sender"
   ClientHeight    =   1710
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3870
   Icon            =   "frmSender.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1710
   ScaleWidth      =   3870
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdGetHwnd 
      Caption         =   "Get Hwnd"
      Height          =   315
      Left            =   2760
      TabIndex        =   4
      Top             =   360
      Width           =   1095
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Height          =   312
      Left            =   2760
      TabIndex        =   1
      Top             =   0
      Width           =   1095
   End
   Begin VB.TextBox txtSend 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2652
   End
   Begin VB.Label lblhWndTarget 
      BackColor       =   &H8000000E&
      BorderStyle     =   1  'Fixed Single
      Enabled         =   0   'False
      Height          =   288
      Left            =   1680
      TabIndex        =   5
      Top             =   360
      Width           =   972
   End
   Begin VB.Label Label3 
      Caption         =   $"frmSender.frx":000C
      Height          =   915
      Left            =   0
      TabIndex        =   3
      Top             =   840
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Target hWnd:"
      Height          =   192
      Left            =   600
      TabIndex        =   2
      Top             =   408
      Width           =   1032
   End
End
Attribute VB_Name = "frmSender"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This demo by Peter Tsakiris 2004, rewritten from an original by Alex Vallat 2000.
'You may free distribute this code as long as this header message remains intact.
'Email the author at petrol_pete@tpg.com.au
'More programs and demos can be found at http://www.comports.com/AlexV

Option Explicit
'API Declares as found in Win32api.txt
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal length As Long)
Private Declare Function CreateFileMapping Lib "kernel32" Alias "CreateFileMappingA" (ByVal hFile As Long, lpFileMappigAttributes As Any, ByVal flProtect As Long, ByVal dwMaximumSizeHigh As Long, ByVal dwMaximumSizeLow As Long, ByVal lpName As String) As Long  'SECURITY_ATTRIBUTES type replaced by Any here, as it is not needed.
Private Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long
Private Declare Function UnmapViewOfFile Lib "kernel32" (lpBaseAddress As Any) As Long
Private Declare Function RegisterWindowMessage Lib "user32.dll" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Const FILE_MAP_WRITE = &H2
Private Const PAGE_READWRITE = &H4
'constant for CreateFileMapping to create file mapping object (FMO) backed by OS pageing file
'rather than named file on disk
Private Const SYSTEM_PAGE_FILE_HWND = &HFFFFFFFF
'End API Declares

'Global Vars
Private hWndTarget As Long 'Target window to send to
Private HwndFileMapObject As Long 'Handle of FMO
Private FileViewHwnd As Long 'Pointer to file view in process' virtual memory

Private Sub cmdGetHwnd_Click()
    
    hWndTarget = FindWindow(vbNullString, "Receiver")
    lblhWndTarget.Caption = CStr(hWndTarget)
    
End Sub

Private Sub Form_Load()
    
    'create file mapping object backed by page file and obtain handle.
    'The name of the FMO, "String File" must match the file that will be opened in the receiver.
    HwndFileMapObject = CreateFileMapping(SYSTEM_PAGE_FILE_HWND, ByVal 0, PAGE_READWRITE, 0, 3000, "StringFile")
    'create file view in local process virtual memory of entire FMO
    If HwndFileMapObject <> 0 Then FileViewHwnd = MapViewOfFile(HwndFileMapObject, FILE_MAP_WRITE, 0, 0, 0)
    'FileViewHwnd now contains the address of memory that can be used
    'by this processes.
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    'unmap file view
    If FileViewHwnd <> 0 Then UnmapViewOfFile FileViewHwnd
    'close FMO
    If HwndFileMapObject <> 0 Then CloseHandle HwndFileMapObject
    
End Sub

Private Sub cmdSend_Click()

    Dim Buffer As String
    Dim StringLength As Long
    
    If hWndTarget = 0 Then Exit Sub
    Buffer = txtSend.Text
    StringLength = Len(Buffer)
    'Copy the string onto the memory map shared area.
    'Source = String Pointer to Buffer variable (string containing text to send)
    'Number of Bytes to copy = Length of string * 2 (Unicode string, so 2 bytes a char)
    CopyMem ByVal FileViewHwnd, ByVal StrPtr(Buffer), StringLength * 2
    'Send the message. Message indicates that string is ready to be received and the lparam passes the length
    SendMessage hWndTarget, WM_MYMESSAGE, 0, ByVal StringLength
    
End Sub

Private Function WM_MYMESSAGE() As Long
'register custom windows message upon first use and obtain issued system wide unique ID upon subsequent call
Static msg As Long
    
    If msg = 0 Then
        msg = RegisterWindowMessage("WM_MYMESSAGE")
    End If
    WM_MYMESSAGE = msg
    
End Function

